/*
 * Q[{
 */

#ifndef _GAME_H_
#define _GAME_H_

#include "type.h"
#include "bitmap.h"

#ifdef GLOBAL_VALUE_DEFINE
#define GLOBAL
#define GLOBAL_VAL(v) = (v)
#else
#define GLOBAL extern
#define GLOBAL_VAL(v)
#endif

void enter_frame( void );
void init_chr( void );
void init_title( void );


/////////////////////////////////////////////////////////////////////e`

#define GM_TITLE (0)// ^Cg
#define GM_INTRO (1)// Cg
#define GM_PLAY (2)// vC
#define GM_OVER (3)// Q[I[o[
#define GM_READY (4)// X^[g

#define DEF_PILLER_WAIT (3) // t[EFCg 60 / 3

#define MACHINE_WIDTH (12)
#define DEF_MACHINE_X ((28 + 72 / 2 ) - MACHINE_WIDTH/2)//@W
#define DEF_MACHINE_Y (8 + 32)

#define START_POSITION ( 8 + 32 - 8)

#define DEF_START_COUNT (60 * 2)

//#define MACHINE_CHR_NOMAL (0)

#define DEF_LIFE (6)//Ct

#define DEF_LV_COUNT (60 * 20)// xAbv̊Ԋu
#define MAX_LEVEL (11)

#define DEF_BLINK_INTERVAL (15)// _ŊԊu 15
#define DEF_BLINK_TIME (60 * 3)// _Ŏ 3s

#define DEF_START_WAIT (4)// X^[gAj̃EFCg

// {[
#define MAX_PILLER (16)
#define PILLER_WIDTH (8)
#define START_PILLER_NUM (4)//L1̐

#define MAX_PILLER_SIZE (24)// ԍ̍ől

#define DEF_HR_WAIT (4)// nAjEFCg

// tHgTCY
#define FONT_READY_WIDTH (38)// READY
#define FONT_LEVEL_WIDTH (32)// LEVEL
#define FONT_PAUSE_WIDTH (24)// PAUSE
#define FONT_SCORE_WIDTH (14)// SCORE
#define FONT_NUM_WIDTH (8 / 2)// 
#define FONT_OVER_WIDTH (72)// GAME OVER
#define FONT_BONUS_WIDTH (34)// +1000pts
#define DEF_NUM_WIDTH (6)

// x\
#define DEF_LEVEL_PRINT_INTERVAL (2)
#define START_LV_POS (14+SCREEN_WIDTH_BLANK)// XChn_
#define LAST_LV_POS (28+SCREEN_WIDTH_BLANK)// XChI_
#define DEF_LV_TIME (60*1) //1s
#define LV_NUM_TIME (DEF_LV_TIME - DEF_LEVEL_PRINT_INTERVAL*(LAST_LV_POS - START_LV_POS) /2)

#define LV_PRINT_NUM_POS_X (60+SCREEN_WIDTH_BLANK)

// |[Y\
#define DEF_PAUSE_PRINT_INTERVAL (2)
#define START_PAUSE_POS (SCREEN_WIDTH - FONT_PAUSE_WIDTH)// XChn_
#define LAST_PAUSE_POS (LCD_WIDTH-FONT_PAUSE_WIDTH+SCREEN_WIDTH_BLANK)// XChI_

// CtH
#define START_INFO_POS (0)// XChn_
#define LAST_INFO_POS (SCREEN_WIDTH_BLANK)// XChI_

// XRA
#define SCORE_DIGIT (6)// 6\
#define SCORE_BONUS (1000)

// 
#define MAX_BOMB (2)
#define BOMB_WIDTH (8)
#define DEF_BOMB_TIME (4*24 + 90)// 4Ŋ؂邱
#define DEF_BOMB_INTERVAL (5)
#define BOMB_ANIME_LIM (4)

// 蔻
#define HIT_PILLER_WIDTH (7)
//#define HIT_BALL_WIDTH (7)
#define HIT_MACHINE_WIDTH (11)

// Q[I[o[
#define DEF_OVER_WAIT (90)
#define OVER_SCORE_POS (10)

// tbV
// LED
#define DEF_FLASH_LED_INTERVAL (15)
#define DEF_FLASH_LED_TIME (DEF_FLASH_LED_INTERVAL*8-1)
// Ó]
#define DEF_FLASH_INTERVAL (12)
#define DEF_FLASH_TIME (DEF_FLASH_INTERVAL)
// BONUS
#define DEF_BONUS_INTERVAL (15)
#define DEF_BONUS_TIME (DEF_BONUS_INTERVAL*8-1)

// ^Cg
#define DEF_TITLE_INTERVAL (30)


typedef struct {
  int mode;
  Boolean pause_f;
  int level;
  int lv_count;
  int piller_num;
  int piller_wait;
  int bomb_time;
  int start_count;
  UInt32 score;
  UInt32 hiscore;
} GameStateType;

typedef struct {
  int x;
  int y;
  int life;
} MachineType;

typedef struct {
  UInt16 x;
  UInt16 num;// LN^ԍ
  int kind;// 
} PillerType;

typedef struct {
  int no;
  int wait;
} HorizonType;

typedef struct {
  Boolean blink_f;//_ŃtO
  int time;//_Ŏ
  int interval;//_ŊԊu
} BlinkType;

typedef struct {
  int wait;
} StartMachineType;

typedef struct {
  int pos_x;
  int time;
  int interval;
} PrintType;

typedef struct {
  int num;
  int interval;
  int x;
  int y;
} BombType;

/////////////////////////////////////////////////////////////////////}N

#define RND(N) ( ( rand() ) % (N))

/////////////////////////////////////////////////////////////////////O[oϐ

GLOBAL MachineType _machine;
GLOBAL PillerType _piller[ MAX_PILLER ];
GLOBAL GameStateType _game_state;
GLOBAL HorizonType _horizon;
GLOBAL UInt16 _seed;
GLOBAL BlinkType _blink;
GLOBAL StartMachineType _start;
GLOBAL PrintType _lv_print;
GLOBAL PrintType _pause_print;
GLOBAL PrintType _info_print;
GLOBAL BombType _bomb[ MAX_BOMB ];
GLOBAL BlinkType _flash;
GLOBAL BlinkType _flash_led;
GLOBAL BlinkType _bonus;
GLOBAL BlinkType _pre_title;

#endif /* _GAME_H_ */
