 /***********************************************************************
 *                                                                      *
 * init.h                                                               *
 * This is initialize driver header file for SVT17702.                  *
 * History:  2008/03/26  Start.                                         *
 *                                                                      *
 ***********************************************************************/


#ifndef _INIT_H
#define _INIT_H

extern void controlPsc(unsigned char control);
extern void debugModePsc(unsigned char debugMode);
extern void setClockGear(unsigned char gear);
extern void controlClg(unsigned char control);
extern void setMiscAccessCycle(unsigned char flashc,unsigned char sramc);
extern void debugModeMisc(unsigned char debugMode);
extern void protectMisc(unsigned char protectMode);
extern void setMiscIramSize(unsigned char iramSize);
extern void setMiscVecAddress(unsigned short baseAddreL,unsigned short baseAddreH);
extern void controlItc(unsigned char control);

#define PSC_PRUN_RUN        	0x1     //Prescaler run control
#define PSC_PRUN_STOP       	0x0     //Prescaler stop control

#define PSC_PRUND_RUN       	0x1     //Prescaler run setting in debug mode
#define PSC_PRUND_STOP      	0x0     //Prescaler stop setting in debug mode

#define CLG_CCLKGR_1       		0x0     //Clock Gear ratio 1
#define CLG_CCLKGR_2       		0x1     //Clock Gear ratio 2
#define CLG_CCLKGR_4       		0x2     //Clock Gear ratio 4
#define CLG_CCLKGR_8       		0x3     //Clock Gear ratio 8

#define CLG_PCLKEN_ENA       	0x3     //PCLK enable
#define CLG_PCLKEN_DIS      	0x0     //PCLK disable

#define MISC_FACCESS_CYCLE_1    0x4     //Flashc read access cycle 1
#define MISC_FACCESS_CYCLE_2    0x0     //Flashc read access cycle 2
#define MISC_FACCESS_CYCLE_3    0x1     //Flashc read access cycle 3
#define MISC_FACCESS_CYCLE_4    0x2     //Flashc read access cycle 4
#define MISC_FACCESS_CYCLE_5    0x3     //Flashc read access cycle 5

#define MISC_SACCESS_CYCLE_2    0x0     //Sramc access cycle 2
#define MISC_SACCESS_CYCLE_3    0x1     //Sramc access cycle 3
#define MISC_SACCESS_CYCLE_4    0x2     //Sramc access cycle 4
#define MISC_SACCESS_CYCLE_5    0x3     //Sramc access cycle 5

#define MISC_O1DBG_RUN   	   	0x1     //OSC1 peripheral run contorl in debug mode
#define MISC_O1DBG_STOP		   	0x0     //OSC1 peripheral stop contorl in debug mode

#define MISC_PROTEC_ON			0x0		//Set the write protect
#define MISC_PROTEC_OFF			0x96	//Remove the write protect

#define MISC_IRAM_12KB			0x0		//Iram size 12kb
#define MISC_IRAM_8KB			0x1		//Iram size 8kb
#define MISC_IRAM_4KB			0x2		//Iram size 4kb
#define MISC_IRAM_2KB			0x3		//Iram size 2kb

#endif


